app.controller("DefaultPageCtrl", function($scope, $state, $ionicLoading, $ionicPopup, $ionicSideMenuDelegate, UserAuthService, SocketService, ChatRoomService) {
    $scope.welcomeMsg = memberDetails.isGuest ? "Welcome Guest" : "Welcome " + memberDetails.displayname;
    $scope.fetchingPlayerMatchData = true;
    $scope.matchData = "0P = 0W, 0L, 0D";
    $scope.newGameWon = 0;
    $scope.joinGameWon = 0;
    $ionicLoading.hide();
    isContinue = false;
    $scope.toggleLeft = function() {
        memberDetails.isGuest ? $state.go('initRouter') : $state.go('defaultpage');
    };
    $scope.logout = function() {
        UserAuthService.logout($state);
    };
    $scope.pendingGames = function() {
        $state.go('pendingGames');
    };
    $scope.completedGames = function() {
        $state.go('completedGames');
    };
    $scope.editMyProfile = function() {
        $state.go('editmyprofile');
    };
    $scope.viewmyplayers = function() {
        $ionicLoading.show();
        fetchMyPlayers();
    };
    $scope.hint = function(){
        var alertPopup = $ionicPopup.alert({
                title: "Use players wisely",
                template: "1st Player hits 4s and 6s but very vulnerable to get caught too,<br /> 2nd plays 4s and keeps his wicket too, <br />3rd & 4th plays wisely to keeps wickets as well, <br />5th & 6th are bowlers and not well trained to bat well, remember! "
            });
    };
    function playerFetched(players) {
        //console.log(players);
        if (players.players.length <= totalWicketsGame) {
            myPlayers = players.players;
            showNewUsers();
        } else {
            myPlayers = players.players;
            loadProfileOfPlayers();
        }
    }

    function showNewUsers() {
        $state.go('updatemyplayers');
    }

    function loadProfileOfPlayers() {
        $state.go('viewmyplayers');
    }

    function fetchMyPlayers() {
        UserAuthService.fetchMyPlayers(playerFetched);
    }
    $scope.errorMsg = "";
    $scope.startGame = function(player, matchname) {
        isJoinedClicked = false;
        UserAuthService.fetchMyPlayers(playerFetchedStartGame);
        //$state.go('playGame');
    };
    $scope.createNewRoom = function(player, matchname) {
        isJoinedClicked = false;
        UserAuthService.fetchMyPlayers(playerFetchedStartGame);
    };

    function playerFetchedStartGame(players) {
        //console.log(players);
        //console.log(isJoinedClicked);
        if (players.players.length <= totalWicketsGame) {
            myPlayers = players.players;
            showNewUsers();
        } else {
            myPlayers = players.players;
            //SocketService.emit('isValidRoom', {room: globalVars.curRoomName}, createMatch);
            SocketService.emit('createNewGame', {
                isJoined: isJoinedClicked
            }, createMatch);
        }
    }

    SocketService.emit('getMatchData', {}, showMatchData);

    function showMatchData(res) {
        //console.log(res.rs);
        $scope.fetchingPlayerMatchData = false;
        $scope.newGameWon = res.rs.first_win_count + 0;
        $scope.joinGameWon = res.rs.second_win_count + 0;
        $scope.pendingCount = res.rs.pending_my_count + res.rs.pending_oppn_count + res.rs.pending_both_count;
        $scope.myPendingCount = res.rs.pending_my_count +0;
        $scope.oppnPendingCount = res.rs.pending_oppn_count + 0;
        //console.log(res.rs);
        $scope.matchData = res.rs.totalplayed + "P = " +
            (res.rs.first_win_count + res.rs.second_win_count) + "W, " +
            (res.rs.totalplayed - res.rs.draw_count - res.rs.first_win_count + res.rs.second_win_count - $scope.pendingCount) + "L, " + (0 + res.rs.draw_count) + "D";
    }

    function createMatch(isValidRoom) {
        //console.log(isValidRoom.matchid);
        if (isValidRoom.issuccess) {
            currMatch = isValidRoom.matchid;
            $state.go('playGame');
        } else {
            $ionicLoading.hide();
            var alertPopup = $ionicPopup.alert({
                title: "No available match found",
                template: "Currently there is no new game to join, you can create new for someone to join."
            });
            //$scope.errorMsg = "Either this name is invalid or already a match is going on with same name.";
        }
    }
    $scope.joinGame = function() {
        $ionicLoading.show();
        isJoinedClicked = true;
        UserAuthService.fetchMyPlayers(playerFetchedStartGame);
    };
    // socket.removeListener('new note');
    // socket.removeListener('console');
    // socket.removeListener('initial notes');
    SocketService.emit('unsubscribe', globalVars.curRoom);

});
app.controller("PendingGamesCtrl", function($scope, $state, $ionicLoading, $ionicPopup, $ionicSideMenuDelegate, UserAuthService, SocketService, ChatRoomService) {
    $ionicLoading.show();
    $scope.gamesList = [];
    $scope.toggleLeft = function() {
        $state.go('defaultpage');
    };
    var gamesFetchSuccess = function(res) {
        angular.forEach(res.rs, function(value) {
            var precsionOvers = Math.floor(value.uido / 6);
            //console.log(precsionOvers);
            var oversPlayed = precsionOvers + "." + (value.uido - (precsionOvers * 6));
            var precsionOversOppn = Math.floor(value.oppno / 6);
            var oversPlayedOppn = precsionOversOppn + "." + (value.oppno - (precsionOversOppn * 6));
            value.name = value.name ? value.name : "(Yet to Join)";
            value.myScore = (value.isJoined == 1 ? value.oppnidscore + "/" + value.oppnw + " (" + oversPlayedOppn + ")" : value.uidscore + "/" + value.uidw + " (" + oversPlayed + ")")
            value.oopnScore = (value.isJoined == 0 ? value.oppnidscore + "/" + value.oppnw + " (" + oversPlayedOppn + ")" : value.uidscore + "/" + value.uidw + " (" + oversPlayed + ")")
            $scope.gamesList.push(value);
        });
        //$scope.gamesList = res.rs;
        //console.log($scope.gamesList);

        $ionicLoading.hide();
    };
    $scope.continueGame = function(item){
        //console.log(item);
        isContinue = true;
        currOppn = item.name; 
        currMatch = item.mid;
        $state.go('playGame');
        //UserAuthService.Games(gamesFetchSuccess);
    };
    UserAuthService.pendingGames(gamesFetchSuccess);

});
app.controller("CompletedGamesCtrl", function($scope, $state, $ionicLoading, $ionicPopup, $ionicSideMenuDelegate, UserAuthService, SocketService, ChatRoomService) {
    $ionicLoading.show();
    $scope.gamesList = [];
    var gamesFetchSuccess = function(res) {
            //console.log(res.rs);
        angular.forEach(res.rs, function(value) {
            var precsionOvers = Math.floor(value.uido / 6);
            var oversPlayed = precsionOvers + "." + (value.uido - (precsionOvers * 6));
            var precsionOversOppn = Math.floor(value.oppno / 6);
            var oversPlayedOppn = precsionOversOppn + "." + (value.oppno - (precsionOversOppn * 6));
            value.myScore = (value.isJoined == 1 ? value.oppnidscore + "/" + value.oppnw + " (" + oversPlayedOppn + ")" : value.uidscore + "/" + value.uidw + " (" + oversPlayed + ")")
            value.oopnScore = (value.isJoined == 0 ? value.oppnidscore + "/" + value.oppnw + " (" + oversPlayedOppn + ")" : value.uidscore + "/" + value.uidw + " (" + oversPlayed + ")")
            $scope.gamesList.push(value);
        });
        //$scope.gamesList = res.rs;
        //console.log($scope.gamesList);

        $ionicLoading.hide();
    };
    UserAuthService.completedGames(gamesFetchSuccess);

});
