app.controller("ReadMessagesCtrl", function($scope, ChatRoomService, $ionicScrollDelegate, $ionicModal,$state, $ionicLoading, SocketService) {
    $scope.msgItems = [];    
    $scope.account = {};
    $scope.account.icon = memberDetails.icon;
    $scope.account.iconcolor = memberDetails.iconcolor;
    $scope.roomname = globalVars.curRoomName;
    $scope.showprofile = {
      displayname: "Guest",
      i: "",
      ic: "",
      msgText: "",
      msgTime: ""
    };
    $ionicModal.fromTemplateUrl('js/templates/common/profile-loader.html', {
      scope: $scope,
      animation: 'nav-title-slide-ios7'
    }).then(function(modal) {
      $scope.modal = modal;
    });
    $scope.showProfile = function(profile, id){
      //console.log(profile);
      $scope.showprofile.displayname = profile.message.sender.displayName;
      $scope.showprofile.id = profile.message.sender.id;
      $scope.showprofile.i = profile.message.sender.icon;
      $scope.showprofile.ic = profile.message.sender.iconcolor;
      $scope.showprofile.msgText = profile.message.txt.msgText;
      $scope.showprofile.msgTime = profile.message.txt.msgTime;
      //console.log($scope.showprofile);
      $scope.modal.show();
    };
    var count = 0;
    var isInitialDataLoaded = false;
    var newMsg;
    var newMsgDetails ;
    var lastMsgTime = 0;
    var successCallbackRead = function (data){
      //console.log(data.length);
      //console.log(lastMsg);
      for (var key = data.length - 1; key > -1; key--) {
        count++;
        newMsg = data[key];
        //console.log(moment(newMsg.msgTime).format('YYYY MM DD, h:mm'));
        //console.log(key);
        lastMsgTime = newMsg.msgTime;
        $scope.msgItems.push({message: {
        sender: {
            displayName: newMsg.name,
            icon: newMsg.icon,
            iconcolor: newMsg.iconcolor
          },
          txt: {
            msgText: newMsg.msgText,
            msgTime: moment(newMsg.msgTime).format('h:mm a MMM, DD')
        }}});
        $ionicScrollDelegate.scrollBottom();
        //console.log(lastMsgTime);
      }
      $ionicScrollDelegate.scrollBottom();
      $ionicLoading.hide();
    };
    //testing socket io to read msgs
    // Initial set of notes, loop through and add to list

    // New socket connected, display new count on page
    
    socket.on('users connected', function(data){
      //console.log('Users connected: ' + data)
    })
    socket.on('console', function(data){
        //console.log(data)
    });
    socket.once('initial notes', function(data){
        //console.log('initial notes')
        successCallbackRead(data);
    });
    socket.on('new note', function(data){
      //console.log(data)
        $scope.chatText = '';  
        successCallbackRead(data);
    });
    $ionicLoading.show({
            template: '<i class="icon ion-loading-c"></i>'
        });

    SocketService.emit('subscribe', globalVars.curRoom);
    SocketService.emit('re-get note', {lastEventTime: lastMsgTime, room: globalVars.curRoom, roomid: globalVars.curRoomId})
    //test end
    var successCallbackPost = function (data){
      if(data.issuccess){
        $scope.chatText = '';        
        SocketService.emit('re-get note', {lastEventTime: lastMsgTime})
      }
      else{
        $state.go('signin');
      }
    };
    $scope.postMessage = function(){
      if($scope.chatText && $scope.chatText.length > 0)
        ChatRoomService.PostChatData("worldchat", $scope.chatText, successCallbackPost);
    };
    $scope.addFriend = function(fid){
      console.log('add - ' + fid);
    };
});