app.controller("StartGameCtrl", function($scope, $state, $filter, $timeout, $ionicLoading, $ionicPopup, $ionicModal, $ionicSideMenuDelegate, UserAuthService, SocketService, ChatRoomService) {
    $scope.matchname = globalVars.curRoomName;
    $scope.welcomeMsg = memberDetails.isGuest ? "Welcome Guest" : memberDetails.displayname + " V/S " + " ?";
    var timerToHitShotInterval = undefined,
        randromRunsInterval = undefined;
    var isBackClicked = false;

    $scope.toggleLeft = function() {
        isBackClicked = true;
        clearIntervals();
        socket.removeListener('matchsubscribed');
        socket.removeListener('scoreupdated');
        socket.removeListener('matchResultUpdated');
        $scope.myPopup ? $scope.myPopup.close() : "";
        showLoader('Saving the match...just a second');
        UserAuthService.saveGame($scope.players, gameSaved);
    };
    var gameSaved = function() {
        memberDetails.isGuest ? $state.go('initRouter') : $state.go('defaultpage');
    };
    var gameSaveContinue = function() {
        //nothing to do
    };
    $scope.players = [{
        "sno": 1,
        "id": myPlayers[0].upid,
        "name": myPlayers[0].name,
        "runs": 0,
        "balls": 0,
        "isActive": true,
        "isBat": 1
    }, {
        "sno": 2,
        "id": myPlayers[1].upid,
        "name": myPlayers[1].name,
        "runs": 0,
        "balls": 0,
        "isActive": true,
        "isBat": 2
    }, {
        "sno": 3,
        "id": myPlayers[2].upid,
        "name": myPlayers[2].name,
        "runs": 0,
        "balls": 0,
        "isActive": false,
        "isBat": 0
    }, {
        "sno": 4,
        "id": myPlayers[3].upid,
        "name": myPlayers[3].name,
        "runs": 0,
        "balls": 0,
        "isActive": false,
        "isBat": 0
    }, {
        "sno": 5,
        "id": myPlayers[4].upid,
        "name": myPlayers[4].name,
        "runs": 0,
        "balls": 0,
        "isActive": false,
        "isBat": 0
    }, {
        "sno": 6,
        "id": myPlayers[5].upid,
        "name": myPlayers[5].name,
        "runs": 0,
        "balls": 0,
        "isActive": false,
        "isBat": 0
    }]
    $scope.opponents = [{
        "id": 1,
        "name": "Player 1",
        "runs": 0,
        "balls": 0,
        "isActive": false,
        "isBat": 0
    }, {
        "id": 2,
        "name": "Player 2",
        "runs": 0,
        "balls": 0,
        "isActive": false,
        "isBat": 0
    }, {
        "id": 3,
        "name": "Player 3",
        "runs": 0,
        "balls": 0,
        "isActive": false,
        "isBat": 0
    }, {
        "id": 4,
        "name": "Player 4",
        "runs": 0,
        "balls": 0,
        "isActive": false,
        "isBat": 0
    }, {
        "id": 5,
        "name": "Player 5",
        "runs": 0,
        "balls": 0,
        "isActive": false,
        "isBat": 0
    }, {
        "id": 6,
        "name": "Player 6",
        "runs": 0,
        "balls": 0,
        "isActive": false,
        "isBat": 0
    }]

    $scope.matchname = memberDetails.displayname + " V/S ...";
    var newRunArray = [];
    $scope.runsScored = $scope.runsScored_oppn = "0/0"
    $scope.oversPlayed = $scope.oversPlayed_oppn = 0;
    var ballPlayed = 0,
        totalRuns = 0,
        totalWickets = 0,
        totalOppnRuns = 0;
    $scope.footerClass = "bar-balanced";
    $scope.footer = "Your first ball is coming. WATCH IT!!! Best of luck!"
    var totalWicketsAllowed = $scope.players.length - 1;
    var totalOvers = 5;
    var totalBalls = totalOvers * 6;
    $scope.matchDetails = totalOvers + " Overs, " + totalWicketsAllowed + " W";
    var isMyInningsEnded = false,
        isOppnInningsEnded = false;
    var oppn_last_played_at = new Date().getTime();

    var showConfirm = function(title, txt, cb, noPopup) {
        var alertPopup = $ionicPopup.alert({
            title: title,
            template: txt
        });
        alertPopup.then(function() {
            //console.log('You are sure');

            playAudio("/android_asset/www/sounds/crowd.mp3")
            if (!noPopup) {
                if (!cb) {
                    // $scope.players[0].isBat = 1;
                    // $scope.players[1].isBat = 2;
                    // $scope.players[0].isActive = true;
                    // $scope.players[1].isActive = true;
                    startMatch();
                } else {
                    $scope.footerClass = "bar-balanced";
                    $scope.footer = "Get ready for the next ball. Best of luck.";
                    $timeout(function() {
                        $scope.showPopup();
                    }, timeBetweenBalls);
                }
            } else {
                if (cb)
                    cb();
                else
                    console.log('end of inning');
            }
        });
    };
    //showLoader(isJoinedClicked ? 'Joining the match...just a second' : 'Please wait for the opponent...');
    SocketService.emit('subscribematch', currMatch);
    var initPlayer = 0;
    var hasPlayerJoined = false;
    //socket.on('matchsubscribed', function(data){
    //console.log("Player joined ");
    /*if(!isJoinedClicked){
      initPlayer = 1;
      showLoader(hasPlayerJoined ? 'opponent has left, you won the match' : 'Please wait for the opponent');
    }
    else { 
      showLoader(initPlayer == 1 ? 'opponent has joined, just few more seconds...' : 'Joining the game, please wait...');
      hasPlayerJoined = true;
      $ionicLoading.hide();
      gameSetUpDoneStartPopUp();
    }*/
    //$ionicLoading.hide();
    //gameSetUpDoneStartPopUp();
    //});
    socket.on('scoreupdated', function(data, runs, overs, oppnname) {
        //console.log(data);
        oppn_last_played_at = new Date().getTime();
        $scope.$apply(function() {
            $scope.matchname = memberDetails.displayname + " V/S " + oppnname;
            $scope.opponents = data;
            $scope.runsScored_oppn = runs;
            $scope.oversPlayed_oppn = overs;
        });
    });
    var outFsImage = "img/out.gif";
    var timeBetweenBalls = 3000;
    $scope.fsImage = outFsImage;
    $ionicModal.fromTemplateUrl('js/templates/common/image-modal.html', {
        scope: $scope,
        animation: 'slide-in-up'
    }).then(function(modal) {
        $scope.fullScreenImageModal = modal;
    });

    function gameSetUpDoneStartPopUp() {
        SocketService.emit('updatemyscore', {
            room: currMatch,
            data: $scope.players,
            runs: $scope.runsScored,
            overs: $scope.oversPlayed,
            name: memberDetails.displayname
        });
        $ionicLoading.hide();
        if (ballPlayed == totalBalls || totalWickets == totalWicketsAllowed) {
            isMyInningsEnded = true;
            $scope.footerClass = "bar-balanced";
            $scope.footer = "You have finished playing your game.";
        } else
            showConfirm('Ready to start the game.', "To go back, click the arrow above...your data will be saved to resume game later.");
    }
    var gameLoaded = function(data) {
        //console.log(data);
        var rs = data.rs,
            playerCount = 0,
            oppnCount = 0,
            oppnRuns = 0,
            oppnW = 0,
            oppnB = 0;
        for (var i = 0; i < rs.length; i++) {
            if (rs[i].uid == sessionData.tempSession) {
                ballPlayed += rs[i].ball;
                totalRuns += rs[i].run;
                totalWickets += (rs[i].isbat == 3 ? 1 : 0);
                $scope.players[playerCount].name = rs[i].name;
                $scope.players[playerCount].id = rs[i].upid;
                $scope.players[playerCount].runs = rs[i].run;
                $scope.players[playerCount].balls = rs[i].ball;
                $scope.players[playerCount].isActive = rs[i].isactive == 1 ? true : false;
                $scope.players[playerCount].isBat = rs[i].isbat;
                playerCount++;
            } else {
                oppnB += rs[i].ball;
                oppnRuns += rs[i].run;
                oppnW += (rs[i].isbat == 3 ? 1 : 0);
                $scope.opponents[oppnCount].name = rs[i].name;
                $scope.opponents[oppnCount].id = rs[i].upid;
                $scope.opponents[oppnCount].runs = rs[i].run;
                $scope.opponents[oppnCount].balls = rs[i].ball;
                $scope.opponents[oppnCount].isActive = rs[i].isactive == 1 ? true : false;
                $scope.opponents[oppnCount].isBat = rs[i].isbat;
                oppnCount++;
            }
        }
        //$scope.runsScored = $scope.runsScored_oppn = "0/0"
        //$scope.oversPlayed = $scope.oversPlayed_oppn = 0;
        $scope.runsScored = calculateTotalRuns();
        $scope.runsScored_oppn = oppnRuns + "/" + oppnW;
        totalOppnRuns = oppnRuns;
        var precsionOvers = Math.floor(ballPlayed / 6);
        var precsionOvers_oppn = Math.floor(oppnB / 6);
        $scope.oversPlayed = precsionOvers + "." + (ballPlayed - (precsionOvers * 6));
        $scope.oversPlayed_oppn = precsionOvers_oppn + "." + (oppnB - (precsionOvers_oppn * 6));
        $scope.matchname = memberDetails.displayname + " V/S " + currOppn;
        $ionicLoading.hide();
        gameSetUpDoneStartPopUp();
    };
    var loadGameHistoryData = function() {
        showLoader('Loading your match data... just a second');
        UserAuthService.loadGame(gameLoaded);
    };
    if (isContinue) {
        loadGameHistoryData();
    } else
        gameSetUpDoneStartPopUp();
    var clearIntervals = function() {
        clearInterval(timerToHitShotInterval);
        clearInterval(randromRunsInterval);
        // timerToHitShotInterval = undefined;
        // randromRunsInterval = undefined;
    }

    function startMatch() {
        $timeout(function() {
            $scope.showPopup();
        }, 1000);
    }
    $scope.newScore = 0;
    $scope.timer = 6;
    var isTapDone = false;
    $scope.showPopup = function() {
        clearIntervals();
        if (isBackClicked) {
            clearIntervals();
            return false;
        }

        $scope.timer = 6;
        //console.log('show popu up timer');
        $scope.data = {}
        $scope.myPopup = $ionicPopup.show({
            template: '<div class = "randScore" ng-click="scored(newScore)" value="10">{{newScore}}</div><div class="title-timer">{{timer}} seconds to go</div>',
            title: '<div class="title-royal">You have 6 seconds to play your shot!</div>',
            subTitle: 'Hit Your Shot, or go for a safe run if lucky it will be a single, no chance of getting out!',
            scope: $scope,
            buttons: [{
                text: 'Take single, if lucky. Be safe!',
                type: 'button-positive',
                onTap: function(e) {
                    //console.log('clicked');
                    $scope.myPopup.close();
                    $scope.scored(Math.floor(Math.random() * 2));
                }
            }, ]
        });
        randromRunsIntervalFn();
        timerToHitShotIntervalFn();
    };

    function nextRandomRunArray() {
        var strikePlayer = $filter('filter')($scope.players, {
            isBat: 1
        })[0];
        if (strikePlayer.sno == 1)
            newRunArray = [4, "caught", 2, 6, 4, 1, "caught", 2, 0, 4, 2, 6, 1, 4, 6, "caught", 2, 6, 4, 2, 1, 4, 6, "bold", "caught", "run out", "LBW"];
        else if (strikePlayer.sno == 2)
            newRunArray = [4, 0, 2, 1, 4, 1, 0, 2, 0, 4, 0, 6, 1, 4, 6, 0, 2, 6, 4, 2, 1, 4, 6, "bold", "caught", "run out", "LBW"];
        else if (strikePlayer.sno == 3 || strikePlayer.sno == 4)
            newRunArray = [1, 2, 0, 1, 0, 4, 0, 1, 0, 2, 0, 3, 0, 4, 0, 1, 0, 6, 1, 2, 0, 1, 0, 4, 0, 1, 0, 2, 0, 3, 0, 4, 0, 1, 0, 6, 1, 2, 0, 1, 0, 4, 0, 1, 0, 2, 0, 3, 0, 4, 0, 1, 0, 6, 1, 2, 0, 1, 0, 4, 0, 1, 0, 2, 0, 3, 0, 4, 0, 1, 0, 6, "bold", "caught", "run out", "LBW"];
        else
            newRunArray = [0, 0, 0, 0, 1, 2, 0, 1, 0, 4, 0, 1, 0, 2, 0, 3, 0, 4, 0, 1, 0, 6, 0, 0 ,0, 1, 2, 0, 1, 0, 4, 0, 1, 0, 2, 0, 3, 0, 4, 0, 1, 0, 6, 1, 2, 0, 1, 0, 4, 0, 1, 0, 2, 0, 3, 0, 4, 0, 1, 0, 6, 1, 2, 0, 1, 0, 4, 0, 1, 0, 2, 0, 3, 0, 4, 0, 1, 0, 6, "bold", "caught", "run out", "LBW"];
    }

    function randromRunsIntervalFn() {
        //if(typeof(randromRunsInterval) !== 'undefined')
        //return;
        nextRandomRunArray();
        randromRunsInterval = setInterval(function() {
            if (isBackClicked) {
                clearInterval(randromRunsInterval);
                return false;
            }
            var rand = newRunArray[Math.floor(Math.random() * newRunArray.length)];
            //console.log(rand);
            $scope.$apply(function() {
                $scope.newScore = rand;
            });
        }, 100);
    }

    function timerToHitShotIntervalFn() {
        //if(typeof(timerToHitShotInterval) !== 'undefined')
        //return;
        timerToHitShotInterval = setInterval(function() {
            if (isBackClicked) {
                clearInterval(timerToHitShotInterval);
                return false;
            }
            //console.log('intervalTimer');
            if ($scope.timer == 0) {
                clearIntervals();
                $scope.scored(0);
                $scope.myPopup.close();
            } else {
                $scope.$apply(function() {
                    $scope.timer--;
                });
            }
        }, 1000);
    }
    var isNextBall = false,
        activePlayer = {},
        inActivePlayer = {};
    $scope.scored = function(val) {
        if (isTapDone) {
            return false;
        }
        isTapDone = true; //disable double tap
        isNextBall = false;
        //console.log('he hit the ball ' + val);
        //console.log(typeof(val));
        ballPlayed++;
        var precsionOvers = Math.floor(ballPlayed / 6);
        $scope.oversPlayed = precsionOvers + "." + (ballPlayed - (precsionOvers * 6));
        $scope.myPopup.close();
        $scope.footer = "Get ready for the match. Best of luck.";
        activePlayer = $filter('filter')($scope.players, {
            isBat: 1
        })[0];
        inActivePlayer = $filter('filter')($scope.players, {
            isBat: 2
        })[0];
        var isNewOver = ballPlayed % 6 == 0 ? true : false;
        var isSideChange = false;
        if (typeof(val) == "number") {
            playShotSound(val)
            $scope.footerClass = "bar-positive";
            isSideChange = val == 1 || val == 3 ? true : false;
            activePlayer.runs += val;
            activePlayer.balls += 1;
            if (ballPlayed >= totalBalls) {
                isBackClicked = true;
                $scope.footer = "That's " + val + " to finish the innings."
                SocketService.emit('updateplayercareer', {
                    upid: activePlayer.id,
                    runs: activePlayer.runs,
                    balls: activePlayer.balls,
                    isOut: false
                });
                SocketService.emit('updateplayercareer', {
                    upid: inActivePlayer.id,
                    runs: inActivePlayer.runs,
                    balls: inActivePlayer.balls,
                    isOut: false
                });
                //myInningHasEnded();
            } else if (isSideChange && !isNewOver) {
                activePlayer.isBat = 2;
                inActivePlayer.isBat = 1;
                isNextBall = true;
                $scope.footer = activePlayer.name + " scored - " + val + ". With this " + val + " run(s), " + inActivePlayer.name + " is on the strike now.";
                //showConfirm(activePlayer.name + " scored - " + val, "Get ready for the next ball", true)
            } else if (isSideChange && isNewOver) {
                isNextBall = true;
                $scope.footer = activePlayer.name + " scored - " + val + " & will keep the strike. Get ready for the first ball of the next over"
                    //showConfirm(activePlayer.name + " scored - " + val, " & will keep the strike. Get ready for the first ball of the next over", true)
            } else if (isNewOver) {
                activePlayer.isBat = 2;
                inActivePlayer.isBat = 1;
                isNextBall = true;
                if (val == 4)
                    $scope.footer = "That's FOUR, awesome shot by " + activePlayer.name + ". End of over, " + inActivePlayer.name + " is now on the strike.";
                else if (val == 6)
                    $scope.footer = "That's SIX, big one by " + activePlayer.name + ". End of over, " + inActivePlayer.name + " is now on the strike.";
                else if (val == 2)
                    $scope.footer = "Nice running between the wickets, 2 more to finish the over." + inActivePlayer.name + " is on the strike now"
                else
                    $scope.footer = "No runs on this ball by " + activePlayer.name;
                //showConfirm(activePlayer.name + " scored - " + val, inActivePlayer.name+ " is on the strike. Get ready for the first ball of the next over.", true)
            } else {
                if (val == 4)
                    $scope.footer = "That's FOUR, awesome shot by " + activePlayer.name + ". He is still on strike. ";
                else if (val == 6)
                    $scope.footer = "That's SIX, big one by " + activePlayer.name + ". He is still on strike. ";
                else if (val == 2)
                    $scope.footer = "Nice running between the wickets, 2 more by " + activePlayer.name;
                else
                    $scope.footer = "No runs on this ball by " + activePlayer.name;
                isNextBall = true;
                //$scope.footer = activePlayer.name + " scored - " + val + ", Get ready for the next ball";
                //showConfirm(activePlayer.name + " scored - " + val, "Get ready for the next ball", true)
            }
        } else {
            playAudio("/android_asset/www/sounds/loud_crowd.mp3")
            $scope.footerClass = "bar-assertive";
            var nextPlayer = $filter('filter')($scope.players, {
                isBat: 0
            })[0];
            activePlayer.balls += 1;
            activePlayer.isActive = false;
            activePlayer.isBat = 3;
            SocketService.emit('updateplayercareer', {
                upid: activePlayer.id,
                runs: activePlayer.runs,
                balls: activePlayer.balls,
                isOut: true
            });
            if (ballPlayed >= totalBalls) {
                //nextBall();
                var notoutPlayer = $filter('filter')($scope.players, {
                    isActive: true
                })[0];
                isBackClicked = true;
                UserAuthService.saveGame($scope.players, gameSaveContinue);
                $scope.footer = "That's " + val + ". That's the end of your innings!"
                SocketService.emit('updateplayercareer', {
                    upid: notoutPlayer.id,
                    runs: notoutPlayer.runs,
                    balls: notoutPlayer.balls,
                    isOut: false
                });
                //myInningHasEnded();
            } else if (nextPlayer && nextPlayer.id != 0) {
                nextPlayer.isActive = true;
                nextPlayer.isBat = 1;
                $scope.footer = "Ouch, " + activePlayer.name + " is " + val + " " + activePlayer.runs + "(" + activePlayer.balls + ")" + ". " + nextPlayer.name + " is in, Get ready for the next ball";
                UserAuthService.saveGame($scope.players, gameSaveContinue);
                isNextBall = true;
                //showConfirm("Ouch, " + activePlayer.name + " is " + val, nextPlayer.name + " is in, Get ready for the next ball", true)
            } else {
                isBackClicked = true;
                var notoutPlayer = $filter('filter')($scope.players, {
                    isActive: true
                })[0];
                SocketService.emit('updateplayercareer', {
                    upid: notoutPlayer.id,
                    runs: notoutPlayer.runs,
                    balls: notoutPlayer.balls,
                    isOut: false
                });
                UserAuthService.saveGame($scope.players, gameSaveContinue);
                $scope.footer = "Ouch, that's - " + val + ", " + activePlayer.name + " is out & that's the end of your innings!";
                //myInningHasEnded();
            }
        }
        if (ballPlayed / 6 == 0) {
            nextPlayer.isBat = 1;
        }
        $scope.runsScored = calculateTotalRuns();
        if (isNextBall)
            nextBall();
        else
            myInningHasEnded();

        clearIntervals();
        SocketService.emit('updatemyscore', {
            room: currMatch,
            data: $scope.players,
            runs: $scope.runsScored,
            overs: $scope.oversPlayed,
            name: memberDetails.displayname
        });
    }

    function myInningHasEnded() {
        evaluateMatchResult();
    }

    function evaluateMatchResult() {
        isMyInningsEnded = true;
        $scope.footer = "Please wait for the results";
        if (isOppnInningsEnded)
            showResultOfMatch(totalRuns, totalOppnRuns);
        //else
        //checkIfOppnHasLeftMatch();
        SocketService.emit('evaluateMatchResult', {
            room: currMatch,
            runs: totalRuns
        });
    }
    socket.on('matchResultUpdated', function(runs) {
        //console.log(runs);
        totalOppnRuns = runs;
        isOppnInningsEnded = true;
        if (isMyInningsEnded)
            showResultOfMatch(totalRuns, totalOppnRuns);
    });

    function checkIfOppnHasLeftMatch() {
        if (isOppnInningsEnded)
            return false;

        if (new Date().getTime() - oppn_last_played_at > 60000) {
            showResultOfMatch(totalRuns, totalOppnRuns);
        } else {
            $timeout(function() {
                checkIfOppnHasLeftMatch();
            }, 15000);
        }
    }

    function showResultOfMatch(myRun, oppnRun) {
        //1- won, 2-lost, 0- draw
        var rs = 0;
        if (myRun > oppnRun) {
            $scope.footer = "You WON!!! Keep it up.";
            rs = isJoinedClicked ? 2 : 1;
        } else if (myRun < oppnRun) {
            $scope.footer = "You LOST!!! Better luck next time.";
            rs = isJoinedClicked ? 1 : 2;
        } else {
            $scope.footer = "That was a draw!!!";
        }

        SocketService.emit('updateMatchResult', {
            room: currMatch,
            score: $scope.runsScored,
            oppnscore: $scope.runsScored_oppn,
            winnerid: rs
        });
    }

    function nextBall() {
        if (!isOppnInningsEnded || (isOppnInningsEnded && totalRuns <= totalOppnRuns)) //opponent has ended already, now my run is more
        {
            $timeout(function() {
                playAudio("/android_asset/www/sounds/crowd.mp3")
                $scope.showPopup();
                isTapDone = false;
            }, timeBetweenBalls);
        } else {
            myInningHasEnded();
            activePlayer = $filter('filter')($scope.players, {
                isBat: 1
            })[0];
            inActivePlayer = $filter('filter')($scope.players, {
                isBat: 2
            })[0];
            if (activePlayer && activePlayer.id)
                SocketService.emit('updateplayercareer', {
                    upid: activePlayer.id,
                    runs: activePlayer.runs,
                    balls: activePlayer.balls,
                    isOut: false
                });
            if (inActivePlayer && inActivePlayer.id)
                SocketService.emit('updateplayercareer', {
                    upid: inActivePlayer.id,
                    runs: inActivePlayer.runs,
                    balls: inActivePlayer.balls,
                    isOut: false
                });
        }
    }

    function calculateTotalRuns() {
        totalRuns = 0, totalWickets = 0;
        for (var j = 0; j < $scope.players.length; j++) {
            totalRuns += $scope.players[j].runs;
            $scope.players[j].isBat == 3 ? totalWickets++ : "";
        }
        return totalRuns + "/" + totalWickets;
    }

    function playShotSound(score) {
        if (score == 4 || score == 6)
            playAudio("/android_asset/www/sounds/loud_crowd.mp3")
        else if (score == 0)
            playAudio("/android_asset/www/sounds/crowd_aww.mp3")

    }

    function playAudio(url) {
        if (typeof(device) == "undefined")
            return;
        var my_media = new Media(url,
            // success callback
            function() {
                console.log("playAudio():Audio Success");
            },
            // error callback
            function(err) {
                console.log(err);
            }
        );
        // Play audio
        my_media.play();
    }

    function showLoader(txt) {
        $ionicLoading.show({
            template: '<i class="icon ion-loading-c">' + txt ? txt : '' + '</i>',
            content: txt ? txt : 'Building game',
            animation: 'fade-in',
            showBackdrop: true,
            maxWidth: 200,
            showDelay: 0
        });
    }
});
