app.service('UserAuthService', function($http, SocketService) {
    this.isUserAlreadyLoggedin = function(successCallback) {
        var res = {};
        if(!sessionData.sessionId || !sessionData.tempSession){
        	res.isUserOnline = false;
        	return successCallback(res);
        }
        SocketService.emit('verify user', 
            { 
                requesting: 'isUserOnline', 
                sessionId: sessionData.sessionId, 
                tempSession: sessionData.tempSession 
            }, successCallback);
    };
    this.logIn = function(loginType, userDetails, successCallback) {
        SocketService.emit('signIn user', { requesting: 'signIn', loginType: loginType, email: userDetails.email, password: userDetails.password, regID: regID }, successCallback)
    };
    this.signUp = function(loginType, userDetails, successCallback) {
		SocketService.emit('signUp user', { requesting: 'signUp', loginType: loginType, email: userDetails.email, password: userDetails.password, displayname: userDetails.displayname, regID: regID }, successCallback)
    };
    this.logout = function($state) {
        sessionData = {};
        memberDetails.isGuest = true;
    	localStorage.removeItem("sessionId");
    	localStorage.removeItem("tempSession");
    	$state.go('signin');
    };
    this.updateProfile = function(userDetails, successCallback) {
    	//console.log(userDetails);
        SocketService.emit('update profile', 
            { 
                requesting: 'updateProfile', 
                sessionId: sessionData.sessionId, 
                tempSession: sessionData.tempSession, 
                email: userDetails.email, 
                displayname: userDetails.dn, 
                i: userDetails.i, 
                ic: userDetails.ic,
                pv_msg: userDetails.pv_msg, 
                pv_add: userDetails.pv_add 
            }, successCallback);
    };
    this.fetchMyPlayers = function(successCallback) {
        SocketService.emit('fetchMyPlayers', {}, successCallback)
    };
    this.insertPlayer = function(newPlayer, successCallback) {
        SocketService.emit('insertPlayer', {'player':newPlayer}, successCallback)
    };
    this.pendingGames = function(successCallback) {
        SocketService.emit('pending games', {}, successCallback)
    };
    this.completedGames = function(successCallback) {
        SocketService.emit('completed games', {}, successCallback)
    };
    this.saveGame = function(players, successCallback) {
        SocketService.emit('save game', {players: players, mid: currMatch}, successCallback)
    };
    this.loadGame = function(successCallback) {
        SocketService.emit('load game', {mid: currMatch}, successCallback)
    };
});